routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Auth::routes();

Route::get('/', 'HomeController@index')->name('home');
Route::get('/portal/dashboard', 'HomeController@dashboard')->name('dashboard');
Route::resource('category', 'Admin\CategoryController');
Route::resource('item', 'Admin\ItemController');
Route::resource('user', 'Admin\UserController');
Route::get('get-item-size-price/{id}', 'Admin\ItemController@loadItemExtraPrice')->name('loadItemExtraPrice');
Route::post('item-size-price', 'Admin\ItemController@addExtraPriceItem')->name('addExtraPriceItem');

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Tymon\JWTAuth\Contracts\JWTSubject;

class User extends Authenticatable implements JWTSubject
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'username', 'email', 'password',
        'first_name','last_name','avatar',
        'user_type','like_items','disliked_items','favourite_items',
        'favourite_categories','preferences','active','verified','last_login_date'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function getJWTIdentifier()
    {
        return $this->getKey();
    }
    public function getJWTCustomClaims()
    {
        return [];
    }

    public function getInfo(){
        return $this->select('name','email')->get();
    }

    public function getFullNameAttribute(){
        return ucfirst($this->first_name . ' ' . $this->last_name );
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\User;
use Validator;
use Session;

class UserController extends BaseController
{
    protected $imageDestination;

    public function __construct() {
        $this->imageDestination = 'uploads/images/users';
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $data['panel'] = 'List of Users';
        $data['rows'] = User::all();
        return view('admin.user.index',compact('data')); 
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $data['panel'] = 'Add User';
        return view('admin.user.create',compact('data')); 
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // dd($request->all());
        $validatedData = $request->validate([
        ]);
        
        try {

            /* Image Process */
            $image_name = '';

            if ($request->hasFile('file')) {
                $file = $request->file('file');
                $imageName = $request->get('username');
                $path = $this->imageDestination;
                $returnedImage = $this->saveUpdateImage($file, $imageName, $path);
                $image_name = $returnedImage;
            }else {
                $image_name = null;
            }

            $user = new User();
            $item->username = $request->username;
            $item->first_name = $request->firstname;
            $item->user_type = $request->usertype;
            $item->avatar = $image_name;

            if ($user->save()) {
                Session::flash('success_message', 'User has been Added.');
                return redirect('user')->with('success_message', 'User added Successfully.');
            } else {
                Session::flash('error_message', 'Item could not be add.');
                return redirect('user')->with('error_message', 'User could not be added.');
            }

        } catch (Exception $e) {
            Session::flash('error_message', 'User could not be add.');
            return redirect('user')->with('error_message', 'User could not be added.');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $data['panel'] = 'Edit User';
        $data['row'] = User::find($id);
        return view('admin.user.edit',compact('data'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
         // dd($request->all());
        $validatedData = $request->validate([
          
        ]);
        
        try {

            $user = User::find($id);

            /* Image Process */
            $image_name = '';           

            if ($request->hasFile('file')) {
                $file = $request->file('file');
                $imageName = $request->get('username');
                $path = $this->imageDestination;
                $returnedImage = $this->saveUpdateImage($file, $imageName, $path);
                $image_name = $returnedImage;
                
                if ($user->avatar) {
                    $old_img = $user->avatar;
                    if (file_exists($old_img)) {
                        unlink($old_img);
                    }
                }
            } elseif (isset($user->avatar) && !empty($user->avatar)) {
                $image_name = $user->avatar;
            }

            $user->title = $request->title;
            $user->username = $request->username;
            $user->first_name = $request->firstname;
            $user->user_type = $request->usertype;
            $user->avatar = $image_name;

            if ($user->save()) {
                Session::flash('success_message', 'User has been Updated.');
                return back();
                // return redirect('user')->with('success_message', 'user updated Successfully.');
            } else {
                Session::flash('error_message', 'User could not be updated.');
                return redirect('user')->with('error_message', 'user could not be updated.');
            }

        } catch (Exception $e) {
            Session::flash('error_message', 'User could not be updated.');
            return redirect('user')->with('error_message', 'User could not be updated.');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function loadItemExtraPrice($id){
        $user = User::find($id);
        if(!$user){
            return response()->json(['msg'=>'User Not found.'],400);
        }
        if($user->delete()){
            return response()->json(['msg'=>'User Deleted.'],200);
        }
      }

}

app/Http/Controllers/Api/UserController.php
<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use JWTAuth;
use Tymon\JWTAuth\Exceptions\JWTException;
use Validator;
use App\User;
use Auth;

use App\Http\Resources\UserResource;



class UserController extends BaseApiController
{
    protected $imageDestination;

    public function __construct() {
        $this->imageDestination = 'uploads/images/users';
    }

    public function authenticate(Request $request)
    {
        $credentials = $request->only('email', 'password');

        try {

            if (! $token = JWTAuth::attempt($credentials)) {
                return response()->json([
                'error' => true,
                'error_msg' => 'Invalid Credentials'
                ], 400);
            }

            
            $user             = User::find(Auth::user()->id);
            $userId           = $user->id;

            $data = [
                        'token' => $token,
                        'user'  => new UserResource($user),
                        'expires_in' => Auth::guard('api')->factory()->getTTL() * 60
                    ];

            return $this->apiResponse(true,"Login Successful",$data,200);

        } catch (JWTException $e) {
            return $this->apiResponse(false,"Couldn't Login.",null,400);
        }

    }

    public function getUserProfile(Request $request){
         try {

            if (! $token = JWTAuth::user()) {
                return response()->json([
                'error' => true,
                'error_msg' => 'Invalid Credentials'
                ], 400);
            }

            $user             = User::find(Auth::user()->id);
            $userId           = $user->id;
            return response([
                'status'        => 'success',
                'error'        =>  false,
                'data'          => $user,
                ], 200);


        } catch (Exception $e) {
            \Log::log('info',"'detailProfile: ".json_encode($e)."'");
        }


    }

    public function register(Request $request)
    {
        
        try {
            
            $validator = Validator::make($request->all(), [
                'username' => 'required|string|max:255',
                'first_name' => 'required|string|max:255',
                'last_name' => 'string|max:255',
                'avatar' => 'image|mimes:jpeg,png,jpg,gif,svg|max:2048',
                'email' => 'required|string|email|max:255|unique:users',
                'password' => 'required|string|min:6|confirmed',
            ]);

             \Log::log('info',"'register: ".json_encode($request->all())."'");


            if($validator->fails()){
                \Log::log('info',"'register: ".json_encode($validator->errors()->toJson())."'");
                    return response()->json(
                        [
                            'status'=> 'error',
                            'error'        =>  true,
                            'error_msg'=>$validator->errors()->toJson()
                        ], 400);
            }



            $requestData = $request->all();


            /* Image Process */
            $image_name = '';

            // sanitize request

            if ($request->hasFile('file')) {
                $file = $request->file('file');
                $imageName = $request->get('username');
                $path = $this->imageDestination;
                $returnedImage = $this->saveUpdateImage($file, $imageName, $path);
                $image_name = $returnedImage;
            }else {
                $image_name = null;
            }

            $user = new User();
            $user->username = $request->get('username');
            $user->first_name = ucfirst(trim($request['first_name']));
            $user->last_name = ucfirst(trim($request['last_name']));
            $user->email = $request['email'];
            $user->user_type = 'customer';
            $user->verified = 0;
            $user->password = bcrypt(trim($request->get('password')));

            $user->avatar = $image_name;

            if($user->save()){
                // $token = JWTAuth::fromUser($user);
                return response()->json(
                    [
                        'status'=>'success',
                        'error'        =>  false,
                        'message'=> 'Congratulation! You have become a member of Sewa Green Top. Please continue to login.'
                    ],200);
            }else{
                return response()->json(
                    [
                        'status'=>  'error',
                        'error'        =>  true,
                        'error_msg'=> 'Unable to confirm your registeration',
                    ], 400);
            }
        } catch (Exception $e) {
            \Log::log('info',"'registerError: ".json_encode($e)."'");
        }


    }

    public function refresh() {
        $token = Auth::guard('api')->refresh();
        if($token){

            return response([
                'status'        => 'success',
                'error'        =>  false,
                'data'          => [
                    'token' => $token,
                    'expires_in' => Auth::guard('api')->factory()->getTTL() * 60
                    ],
                ], 200);


        }else{
            return response()->json(
                    [
                        'status'=>  'error',
                        'error'        =>  true,
                        'error_msg'=> 'Unable to confirm your process.',
                    ], 400);
        }
    }

    public function getAuthenticatedUser()
    {
        try {

            if (! $user = JWTAuth::parseToken()->authenticate()) {
                    return response()->json(['user_not_found'], 404);
            }

        } catch (Tymon\JWTAuth\Exceptions\TokenExpiredException $e) {

                return response()->json(['token_expired'], $e->getStatusCode());

        } catch (Tymon\JWTAuth\Exceptions\TokenInvalidException $e) {

                return response()->json(['token_invalid'], $e->getStatusCode());

        } catch (Tymon\JWTAuth\Exceptions\JWTException $e) {

                return response()->json(['token_absent'], $e->getStatusCode());

        }

        return response()->json(compact('user'));
    }

    public function logoutUser() {

        Auth::guard('api')->logout();
        if(JWTAuth::parseToken()){
            return response()->json([
                'status' => 'success',
                'error' => false,
                'message' => 'You have been logout.'
            ], 200);
        }else{
            return response()->json([
                'status' => 'Error',
                'error' => true,
                'message' => 'Please try again.'
            ], 200);
        }

        
    }

}

resources/views/admin/user/create.blade.php
@extends('admin.layouts.master')

@section('content')
<h1 class="h3 mb-4 text-gray-800">{{ $data['panel'] }}</h1>
<div class="row">
    <div class="offset-2 col-8 offset-2">
        <div class="card shadow mb-4">
            <!-- Card Header - Accordion -->
            <a href="#collapseForm" class="d-block card-header py-3" data-toggle="collapse" role="button" aria-expanded="true" aria-controls="collapseForm">
              <h6 class="m-0 font-weight-bold text-primary">Add Item</h6>
            </a>

            <!-- Card Content - Collapse -->
            <div class="collapse show" id="collapseForm">
              <div class="card-body">
                <form id="categoryForm" method="post" action="{{ route('item.store') }}" enctype="multipart/form-data">
                    @csrf
                    @include('admin.item.form')
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
              </div>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/admin/user/edit.blade.php
@extends('admin.layouts.master')

@section('content')
<h1 class="h3 mb-4 text-gray-800">{{ $data['panel'] }}</h1>
<div class="row">
    <div class="col-8">
        <div class="card shadow mb-4">
            <!-- Card Header - Accordion -->
            <a href="#collapseForm" class="d-block card-header py-3" data-toggle="collapse" role="button" aria-expanded="true" aria-controls="collapseForm">
              <h6 class="m-0 font-weight-bold text-primary">Edit Category</h6>
            </a>

            <!-- Card Content - Collapse -->
            <div class="collapse show" id="collapseForm">
              <div class="card-body">
                <form method="POST" action="{{ route('item.update', ['id' => $data['row']->id]) }}" accept-charset="UTF-8" enctype="multipart/form-data" id="editForm">
                    <input type="hidden" name="_method" value="PUT">
                    @csrf
                    @include('admin.item.form')
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
              </div>
            </div>
        </div>
    </div>
    <div class="col-4">
        @if(isset($data['row']))
            <img src="{{ $data['row']->processImage()}}" width="100%" height="250px">
        @endif
    </div>
</div>

@endsection

resources/views/admin/user/form.blade.php
<div class="form-group">
    <label for="">Choose Category</label>
    <select name="category_id" class="form-control" id="parentCategory">
        <option value="">Select Category</option>
            @foreach (json_decode($data["categories"], true) as $optionKey => $optionValue)
                <option value="{{ $optionKey }}" {{ (isset($data['row']->category_id) && $data['row']->category_id == $optionKey) ? 'selected' : ''}}>{{ $optionValue }}</option>
            @endforeach
    </select>
    <span class="text-danger">{{ $errors->first('category_id') }}</span>
</div>

<div class="form-group">
    <label for="">Name</label>
    <input type="text" class="form-control" id="itemName" name="title" placeholder="Enter Item Name" autocomplete="off" value="{{ old('title')?? (isset($data['row'])? $data['row']->title:'')  }}">
    <span class="text-danger">{{ $errors->first('title') }}</span>
</div>

<div class="form-group">
    <label for="">Featured Image</label>
    <input id="fileupload" type="file" name="file" data-folder="items">
    <span class="text-danger">{{ $errors->first('file') }}</span>
</div>

<div class="form-group">
    <label for="">Description</label>
    <textarea class="form-control" id="summernote" name="description" autocomplete="off">
        {{ old('description')?? (isset($data['row'])? $data['row']->description:'') }}
    </textarea>
    <span class="text-danger">{{ $errors->first('description') }}</span>
</div>


<div class="form-group">
    <label for="">Has Different Price?</label>
    <select name="hasSize" class="form-control" id="hasSize" >
        @foreach (json_decode('{"0": "No", "1": "Yes"}', true) as $optionKey => $optionValue)
            <option value="{{ $optionKey }}" {{ (isset($data['row']->hasSize) && $data['row']->hasSize == $optionKey) ? 'selected' : ''}}>{{ $optionValue }}</option>
        @endforeach
    </select>
    <span class="text-danger">{{ $errors->first('status') }}</span>
</div>

<div class="form-group" id="priceForm">
    <label for="">Price</label>
    <input type="text" class="form-control" id="itemPrice" name="price" placeholder="Enter Item Name" autocomplete="off" value="{{ old('price')?? (isset($data['row'])? $data['row']->price:'')  }}">
    <span class="text-danger">{{ $errors->first('price') }}</span>
</div>
@if(isset($data['row']))
<div class="form-group" id="showExtraPriceForm">
@include('admin.item.subform')
</div>
@endif

<div class="form-group">
    <label for="" class="mr-2">Item Type</label>
    @php
        if(isset($data['row'])):
            $notApplicable = ($data['row']->dishType == 'NotApplicable')? 'checked':'';
            $veg = ($data['row']->dishType == 'Veg')? 'checked':'';
            $nonVeg = ($data['row']->dishType == 'NonVeg')? 'checked':'';
        endif    
    @endphp
    <input type="radio" name="dishType" value="NotApplicable" {{( $notApplicable)?? '' }} > <span class="text-gray-700 mr-1 font-weight-bold"> Not Applicable </span>
    <input type="radio" name="dishType" value="Veg" {{ ($veg)?? ''}}> <span class="text-success mr-1 font-weight-bold"> Vegeterian</span> 
    <input type="radio" name="dishType" value="NonVeg" {{ ($nonVeg)?? ''}}> <span class="text-danger mr-1 font-weight-bold"> Non Vegeterian</span>
    <span class="text-danger">{{ $errors->first('dishType') }}</span>
</div>

<div class="form-group row">
    <div class="col-6">
         <label for="">Featured</label>
        <select name="featured" class="form-control" id="featured" >
            @foreach (json_decode('{"1": "Yes", "0": "No"}', true) as $optionKey => $optionValue)
                <option value="{{ $optionKey }}" {{ (isset($data['row']->featured) && $data['row']->featured == $optionKey) ? 'selected' : ''}}>{{ $optionValue }}</option>
            @endforeach
        </select>
        <span class="text-danger">{{ $errors->first('featured') }}</span>
    </div>
    <div class="col-6">
        <label for="">Status</label>
        <select name="status" class="form-control" id="status" >
            @foreach (json_decode('{"1": "Published", "0": "Not Published"}', true) as $optionKey => $optionValue)
                <option value="{{ $optionKey }}" {{ (isset($data['row']->status) && $data['row']->status == $optionKey) ? 'selected' : ''}}>{{ $optionValue }}</option>
            @endforeach
        </select>
        <span class="text-danger">{{ $errors->first('status') }}</span>
    </div>
</div>

@section('styles')
<link rel="stylesheet" type="text/css" href="{{ asset('assets/backend/vendor/summernote/summernote-bs4.css') }}">
<link rel="stylesheet" type="text/css" href="{{ asset('assets/backend/vendor/select2/css/select2.min.css') }}">

@endsection

@section('scripts')
<script type="text/javascript" src="{{ asset('assets/backend/vendor/summernote/summernote-bs4.min.js') }}"></script>
<script type="text/javascript" src="{{ asset('assets/backend/vendor/select2/js/select2.min.js') }}"></script>
<script type="text/javascript">
    $(document).ready(function() {
        
        function showHideExtraPriceForm(hasSize){
            var formId = hasSize.parents("form").attr("id");

            if( formId == 'editForm' && hasSize.val() == 1){
                    $('#showExtraPriceForm').show();
            }else if(formId == 'editForm' && hasSize.val() == 0){
                $('#showExtraPriceForm').hide();
            }else if(hasSize.val() == 0){
                $('#showExtraPriceForm').hide();
            }
        }

        function checkForPrice(){
            if($('#hasSize').val() == 1){
                $('#priceForm').hide();
                showHideExtraPriceForm($('#hasSize'));
               
            }else{
                $('#priceForm').show();
                showHideExtraPriceForm($('#hasSize'));
            }
        }
      
        checkForPrice();      
        $("#parentCategory").select2({
            placeholder: "Select a Category",
            allowClear: true
        });

        $('#summernote').summernote({
            height: 150,
        });
        $('#hasSize').on('change',function(e){
            checkForPrice();
        });


    });
</script>
@endsection

resources/views/admin/user/index.blade.php
@extends('admin.layouts.master')

@section('content')
<h1 class="h3 mb-4 text-gray-800">{{ $data['panel'] }}</h1>
<div class="row">
    <div class="col-4">
        <div class="card shadow mb-4">
            <!-- Card Header - Accordion -->
            <a href="#collapseForm" class="d-block card-header py-3" data-toggle="collapse" role="button" aria-expanded="true" aria-controls="collapseForm">
              <h6 class="m-0 font-weight-bold text-primary">Add Category</h6>
            </a>

            <!-- Card Content - Collapse -->
            <div class="collapse show" id="collapseForm">
              <div class="card-body">
                <form id="categoryForm" method="post" action="javascript:void(0)">
                  @csrf
                    <div class="form-group">
                        <label for="">Choose Parent Category</label>
                        <select name="parentCategory" class="form-control" id="parentCategory">
                            <option value="">Please Choose</option>
                        </select>
                        <span class="text-danger">{{ $errors->first('parentCategory') }}</span>
                    </div>

                    <div class="form-group">
                        <label for="">Category Title</label>
                        <input type="text" class="form-control" id="categoryTitle" placeholder="Enter Category Title">
                        <span class="text-danger">{{ $errors->first('categoryTitle') }}</span>
                    </div>

                    <div class="form-group">
                        <label for="">Category Title</label>
                        <input id="fileupload" type="file" name="file" data-folder="category">
                        <span class="text-danger">{{ $errors->first('file') }}</span>
                    </div>

                    <div class="form-group">
                        <label for="">Category Title</label>
                        <textarea class="form-control" id="summernote" name="description">
                        </textarea>
                        <span class="text-danger">{{ $errors->first('description') }}</span>

                    </div>

                    <div class="form-group">
                        <label for="">Status</label>
                        <select name="status" class="form-control" id="status" >
                            @foreach (json_decode('{"1": "Published", "0": "Not Published"}', true) as $optionKey => $optionValue)
                                <option value="{{ $optionKey }}" {{ (isset($data['row']->status) && $data['row']->status == $optionKey) ? 'selected' : ''}}>{{ $optionValue }}</option>
                            @endforeach
                        </select>
                        <span class="text-danger">{{ $errors->first('status') }}</span>

                    </div>

                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>
              </div>
            </div>
        </div>
    </div>

    <div class="col-8">
        <div class="card shadow mb-4">
            
            <!-- Card Header - Accordion -->
            <a href="#collapseCardExample" class="d-block card-header py-3" data-toggle="collapse" role="button" aria-expanded="true" aria-controls="collapseCardExample">
              <h6 class="m-0 font-weight-bold text-primary">Collapsable Card Example</h6>
            </a>

            <!-- Card Content - Collapse -->
            <div class="collapse show" id="collapseCardExample">
              <div class="card-body">
                This is a collapsable card example using Bootstrap's built in collapse functionality. <strong>Click on the card header</strong> to see the card body collapse and expand!
              </div>
            </div>

        </div>
    </div>
</div>

@endsection

@section('styles')
<link rel="stylesheet" type="text/css" href="{{ asset('assets/backend/vendor/summernote/summernote-bs4.css') }}">
@endsection

@section('scripts')
<script type="text/javascript" src="{{ asset('assets/backend/vendor/summernote/summernote-bs4.min.js') }}"></script>
<script type="text/javascript">
    $(document).ready(function() {
      $('#summernote').summernote({
        height: 150,
      });
    });
</script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.0/jquery.validate.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.0/additional-methods.min.js"></script>
@endsection